/// <reference types="node" />
import type { RxDatabase, RxPlugin } from '../types';
export declare function spawnServer(this: RxDatabase, { path, port, cors, startServer, pouchdbExpressOptions }: {
    path?: string | undefined;
    port?: number | undefined;
    cors?: boolean | undefined;
    startServer?: boolean | undefined;
    pouchdbExpressOptions?: {} | undefined;
}): {
    app: import("express-serve-static-core").Express;
    pouchApp: any;
    server: import("http").Server | null;
};
/**
 * when a server is created, no more collections can be spawned
 */
declare function ensureNoMoreCollections(args: any): void;
/**
 * runs when the database gets destroyed
 */
export declare function onDestroy(db: RxDatabase): void;
export declare const rxdb = true;
export declare const prototypes: {
    RxDatabase: (proto: any) => void;
};
export declare const hooks: {
    preDestroyRxDatabase: typeof onDestroy;
    preCreateRxCollection: typeof ensureNoMoreCollections;
};
export declare const overwritable: {};
export declare const RxDBServerPlugin: RxPlugin;
export {};
